const Http = require("../../utils/HttpBasics");
const config = require("../../config/config");
let app = getApp();
const imgurl = require("../../utils/imgurl");
Page({

  /**
   * 页面的初始数据
   */
  data: {
    src: imgurl.grade.url,
    actUrl: imgurl.act.url,
    gradeUrl: imgurl.grade.url,
    grade1Url: imgurl.grade1.url,
    grade2Url: imgurl.grade2.url,
    grade3Url: imgurl.grade3.url,
    growthbgUrl: imgurl.growthbg.url,
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function(options) {

  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function() {
    let that = this;
    Http.get({
      url: config.api.scoreLevelInfo,
      data: {}
    })
    .then(res=>{
      that.setData({
        flags: 'have',
        rules: JSON.parse(res.data.score.rules).concat(JSON.parse(res.data.score.rules)[1].childs),
        levelList: res.data.levelList
      })
      console.log(that.data.rules)
    })
    .catch(res=>{
      that.setData({
        flags: 'nothave'
      })
    })
    
  },
  // 点击跳转到我的特享优惠
  gotospecialcourtesy:function(){
    wx.navigateTo({
      url: '/pages/specialcourtesy/specialcourtesy',
    })
  }
})