var config = require("../../config/config.js");
var app = getApp();
const Http = require("../../utils/HttpBasics");
const imgurl = require("../../utils/imgurl");
Page({
  /**
   * 页面的初始数据
   */
  data: {
    myspeacialUrl: imgurl.myspeacial.url,
    teliconUrl: imgurl.telicon.url,
  },
  phone: function (e) {
    console.log(e)
    let that = this;
    wx.makePhoneCall({
      phoneNumber: e.currentTarget.dataset.merchantlinkphone
    });
  },
  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    let that = this;
    Http.get({
      url: config.api.getDiscountInfo,
      data: {}
    })
    .then(res=>{
      that.setData({
        level: res.data.level ? res.data.level : ''
      })
      console.log(res.data.levelMerchantList)
      let discountMerchantList = [];
      res.data.levelMerchantList.map(file=>{
        if (file.discount != 100){
          discountMerchantList.push(file);
        }
      })
      console.log(discountMerchantList)
      that.setData({
        discountMerchantList: discountMerchantList,
      })
    })
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },
})